package simulator.stats;


/**
 * Gathers the statistics values used internally
 * @author Stanislaw Szczepanowski
 */
public class StatisticsInfo {

	/** The mean value */
	protected DCwormsAccumulator mean;
	/** The standard deviation value */
	protected DCwormsAccumulator stdev;
	/** The minimal value */
	protected DCwormsAccumulator max;
	/** The maximal value */
	protected DCwormsAccumulator min;
	/**
	 * @param mean
	 * @param stdev
	 * @param max
	 * @param min
	 */
	public StatisticsInfo(DCwormsAccumulator mean, DCwormsAccumulator stdev, DCwormsAccumulator max, DCwormsAccumulator min) {
		this.mean = mean;
		this.stdev = stdev;
		this.max = max;
		this.min = min;
	}
	/**
	 * @return the maximal value
	 */
	public DCwormsAccumulator getMax() {
		return max;
	}
	/**
	 * @return the mean value
	 */
	public DCwormsAccumulator getMean() {
		return mean;
	}
	/**
	 * @return the minimal value
	 */
	public DCwormsAccumulator getMin() {
		return min;
	}
	/**
	 * @return the standard deviation value
	 */
	public DCwormsAccumulator getStdev() {
		return stdev;
	}
}