package simulator.stats.implementation;

import simulator.stats.DCwormsAccumulator;
import simulator.stats.implementation.out.StatsSerializer;

/**
 * 
 * @author Marcin Krystek
 * 
 */
public class AccumulatedResourceStats implements StatsInterface {

	// accumulated resource statistic
	protected DCwormsAccumulator resourceLoad;
	protected DCwormsAccumulator resourceReservationLoad;
	protected String resourceName;

	private String[] headers = { "Resource name", "Factor's name", "mean",
			"stdev", "variance", "minimum", "maximum", "sum", "count" };

	public AccumulatedResourceStats(String resourceName) {
		this.resourceName = resourceName;
		this.resourceLoad = new DCwormsAccumulator();
		this.resourceReservationLoad = new DCwormsAccumulator();
	}

	public String getResourceName() {
		return this.resourceName;
	}

	public void addResourceLoad(double load) {
		this.resourceLoad.add(load);
	}

	public void addReservationLoad(double load) {
		this.resourceReservationLoad.add(load);
	}

	public DCwormsAccumulator getResourceLoad() {
		return this.resourceLoad;
	}

	public DCwormsAccumulator getResourceReservationLoad() {
		return this.resourceReservationLoad;
	}

	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
